.failed-jobs-report:
  variables:
    FAILED_JOB_NAME: "review-deploy"
    REPORT_HOURS: 24
  script:
    # `gitlab-bot` token: "Token used in gitlab-org/quality/toolbox"
    - bin/failed_jobs_report --token=$GITLAB_BOT_ACCESS_TOKEN --group-by-mr --hours=$REPORT_HOURS --output=slack --job=$FAILED_JOB_NAME
  artifacts:
    paths:
      - failed_jobs_report.json
    when: always

failed-jobs-report:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule" && $REPORT_TYPE == "FAILED JOB REPORT"'
    - if: '$CI_MERGE_REQUEST_IID'
      when: manual
      allow_failure: true
  extends: .failed-jobs-report
  stage: report
  dependencies: []
  retry: 2
  script:
    - !reference [.failed-jobs-report, script]
    - |
      curl -X POST -H 'Content-Type: application/json' --data @failed_jobs_report.json "$SLACK_WEBHOOK"

test:failed_jobs_report:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule" && $REPORT_TYPE != "FAILED JOB REPORT"'
      when: never
    - when: on_success
  extends: .failed-jobs-report
  stage: test
  script:
    - !reference [.failed-jobs-report, script]
    - bundle exec jsonlint failed_jobs_report.json
